extends ../_docs-template

block vars
  - var title = 'Sortable List | Framework7 Documentation';

block docs-index

block content


  .docs-nav
    include ../_docs-menu
  .docs-content
    .motion-docs-page-title
      h1 Sortable List
      script(src="/js/motion/sortablelist.js")
      f7-motion-sortablelist(motion)

    p Sortable lists is an extension of <a href="list-view.html">List View</a> that allows you to sort list view elements.
    h2 Sortable List Layout
    p Let's look at layout structure of sortable lists in your list views:
    :code(lang="html")
      <!-- Additional "sortable" class on list block -->
      <div class="list sortable">
          <li>
              <div class="item-content">
                  <div class="item-media">...</div>
                  <div class="item-inner">...</div>
              </div>
              <!-- Sortable handler element -->
              <div class="sortable-handler"></div>
          </li>
          ...
      </div>
    p Where:
    ul
      li `sortable-handler` - "draggable" element (hidden by default) that allows you to sort current list view element
    p As you may see it is pretty simple, all you need is to add `sortable` class to list block and put `<div class="sortable-handler">&lt;/div&gt;` as a direct child of `<li>`.

    h4 Disable Sorting
    p If we need to disable sorting on some specific items we can add `no-sorting` or `disallow-sorting` class to those items:
    :code(lang="html")
      <!-- Additional "sortable" class on list block -->
      <div class="list sortable">
          <!-- disable sorting for this item -->
          <li class="no-sorting">...</li>

          <!-- sortable items -->
          <li>...</li>
          <li>...</li>
      </div>
    p Note, that it makes sense and work only on first or last items in the list and won't work correctly if you disable sortable for some of the items in the middle.

    h4 Opposite Sortable
    p If we need to render sortable handler on opposite side (e.g. on left in LTR direction) we need to add `sortable-opposite` side to sortable list:
    ```html
      <!-- Additional "sortable-opposite" class on sortable list -->
      <div class="list sortable sortable-opposite">
        <li>
          <div class="item-content">
            <div class="item-media">...</div>
            <div class="item-inner">...</div>
          </div>
          <!-- Sortable handler element -->
          <div class="sortable-handler"></div>
        </li>
        ...
      </div>
    ```

    h2 Sortable App Methods
    p To enable/disable sorting mode on sortable list we need to use following app methods:
    .method-wrap
      p
        span.method app.sortable.enable(<span>listEl</span>)
        | - enable sorting mode on sortable list
      ul.method-parameters
        li
          span.parameter listEl
          |  - <span class="parameter-type">HTMLElement</span> or <span class="parameter-type">string</span> (with CSS Selector). Sortable list block element.
    .method-wrap
      p
        span.method app.sortable.disable(<span>listEl</span>)
        | - disable sorting mode on sortable list
      ul.method-parameters
        li
          span.parameter listEl
          |  - <span class="parameter-type">HTMLElement</span> or <span class="parameter-type">string</span> (with CSS Selector). Sortable list block element.
    .method-wrap
      p
        span.method app.sortable.toggle(<span>listEl</span>)
        | - toggle sorting mode on sortable list
      ul.method-parameters
        li
          span.parameter listEl
          |  - <span class="parameter-type">HTMLElement</span> or <span class="parameter-type">string</span> (with CSS Selector). Sortable list block element.
    h2 Sortable App Parameters
    p It is possible to configure global sortable behavior on app initialisation by passing sortable related paremeters under `sortable` property.
    table.params-table
      thead
        tr
          th Parameter
          th Type
          th Default
          th Description
      tbody
        tr
          td moveElements
          td boolean
          td true
          td
            p When enabled then it will move (reorder) HTML elements according to new sortable order. It is useful to disable it if you use other library for DOM manipulation, like React or Vue.
            p It is also possible to overwrite this behavior for specific lists by adding `data-sortable-move-elements="true"` or `data-sortable-move-elements="false"` attribute to list element.
    p To change these parameters we need to pass them on app init under `sortable` property, for example:
    :code(lang="js")
          var app = new Framework7({
            sortable: {
              moveElements: false
            }
          });

    h2 Sortable Events
    p Sortable will fire the following DOM events on sortable list block element and events on app instance:
    h3 DOM Events
    table.events-table
      thead
        tr
          th Event
          th Target
          th Description
      tbody
        tr
          td sortable:enable
          td Sortable List<span>&lt;div class="list sortable"&gt;</span>
          td Event will be triggered when sortable mode is enabled
        tr
          td sortable:disable
          td Sortable List<span>&lt;div class="list sortable"&gt;</span>
          td Event will be triggered when sortable mode is disabled
        tr
          td sortable:sort
          td List element<span>&lt;li&gt;</span>
          td Event will be triggered after user release currently sorting element in new position. `event.detail` will contain object with `from` and `to` properties with from/to index numbers of sorted list item and `el` property with HTML sorted element
        tr
          td sortable:move
          td List element<span>&lt;li&gt;</span>
          td Event will be triggered on every list item move during sorting
    h3 App Instance Events
    p Sortable instance emit events on app instance.
    table.events-table
      thead
        tr
          th Event
          th Target
          th Arguments
          th Description
      tbody
        tr
          td sortableEnable
          td app
          td <span>listEl</span>
          td Event will be triggered when sortable mode is enabled
        tr
          td sortableDisable
          td app
          td <span>listEl</span>
          td Event will be triggered when sortable mode is disabled
        tr
          td sortableSort
          td app
          td <span>itemEl, data, listEl</span>
          td Event will be triggered after user release currently sorting element in new position. `data` is an object with `from` and `to` properties with from/to index numbers of sorted list item `el` property with HTML sorted element
        tr
          td sortableMove
          td app
          td <span>itemEl, listEl</span>
          td Event will be triggered on every list item move during sorting
    h2 Sortable On Tap Hold
    p It is possible to bypass sortable enable/disable logic and make list items sortable on item tap and hold (long press). To make it work, we just need additional `sortable-tap-hold` class on sortable list:
    ```html
      <!-- additional "sortable-tap-hold" class on sortable list -->
      <div class="list sortable sortable-tap-hold">
        ...
      </div>
    ```
    p In this case app will rely on custom `taphold` event. To make it work correctly, make sure you have also enabled `touch.tapHold: true` #[a(href="app.html#app-parameters" target="_blank") app parameter]
    h2 Control Sortable With Links
    p It is possible to enable and disable sortable mode using special classes and data attributes on links:
    .important-note
      ul
        li
          p To enable sortable mode we need to add `sortable-enable` class to any HTML element (preferred to link)
        li
          p To disable sortable mode we need to add `sortable-disable` class to any HTML element (preferred to link)
        li
          p To toggle sortable mode we need to add `sortable-toggle` class to any HTML element (preferred to link)
        li
          p If you have more than one sortable list in app, you need to specify appropriate sortable list via additional `data-sortable=".sortable"` attribute on this HTML element with CSS selector of required sortable list

    +cssVars('sortable')

    h2 Examples
    +examplePreview('core', 'sortable.html', 'sortable')
